#######################################################
# NewcalEnter.pl for SP1 mod by Ironwing and GauGau.	#
# Based on Event Calendar by Nermware			#
# Support: boardmod.yabbforums.com				#
# Version 3.7a	EMS Special						#
#######################################################
# EnterData routine
# EditData routine
# NewData routine
# CompactCal routine
#######################################################
$NewcalEnterplver = 'Newcalendar 3.7a EMS Special';

# EnterData generates Edit Event page, called by CalMain
sub EnterData {
	my($entrynum) = $INFO{'entrynum'};
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		$entrynum2 = 0;
		foreach $entry (@{ $dayinfo{$daynum} }) {
			my(@daydata) = split(/\{/,$entry);
			$dayvars[$entrynum2] = [ @daydata ];
			$entrynum2++;
		}
	}
#####

	my($eventusername) = 'Invalid user name placeholder'; #Sets variable to string no legitimate user name could possibly be.
	chomp $newcaladmingroup;
	@newcaladmingrouplist = split(",",$newcaladmingroup);
	$newcaladmingroupflag = 0;
	foreach $newcaladmingroupitem (@newcaladmingrouplist) {
		if ($settings[7] eq $newcaladmingroupitem) { $newcaladmingroupflag = 1; }
	}
	($thisdaymonth,$thismonth,$thisyear,$thisdayweek) = (gmtime($daynum))[3,4,5,6];
	$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	$thisyear += 1900;
	if ($newcaldate == 1) {
		$newcaldatestring = qq~$thisweekdayname $thisdaymonth. $monthname $thisyear~;
		$newcaldatestring2 = qq~$thisweekdayname $thisdaymonth. <A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selyear=$thisyear&acttype=display">$monthname</A> <A HREF="$scripturl?action=newcalendar&selyear=$thisyear&acttype=disyear">$thisyear</A>~;
	} else {
		$newcaldatestring = qq~$thisweekdayname, $monthname $thisdaymonth, $thisyear~;
		$newcaldatestring2 = qq~$thisweekdayname, <A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selyear=$thisyear&acttype=display">$monthname</A> $thisdaymonth, <A HREF="$scripturl?action=newcalendar&selyear=$thisyear&acttype=disyear">$thisyear</A>~;
	}
	my($subject) = "";
	my($commentview) = "";
	$yymain .= qq~
<CENTER>
  <SPAN class="newcal31">$ecaltxt{'49'}$newcaldatestring2</SPAN>
  <FORM method="POST"  enctype="application/x-www-form-urlencoded">
    <INPUT type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
  </FORM>
  <HR width="80%">
  <TABLE border=0 width=80%>
    <TR>
      <TD colspan=2><HR width=97% size=4></TD>
    </TR>
	~;
	$entrynum2--;
	$userhasanevent = 0;
	for ($entrynum=0;$entrynum<=$entrynum2;$entrynum++) {
		next if !(defined(${$dayvars[$entrynum]}[0]));
		next if(${$dayvars[$entrynum]}[1] =~ /DELETED/);
		$commentview = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
		($commentview,$dummy) = split('',$commentview);
		$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
###
		if($username eq $eventusername || $settings[7] eq 'Administrator' || $newcaladmingroupflag == 1) {
			$userhasanevent = 1;
###
		&LoadCensorList;
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$commentview =~ s~\Q$tmpa\E~$tmpb~gi;
			${$dayvars[$entrynum]}[0] =~ s~\Q$tmpa\E~$tmpb~gi;
		}
		if( $eventusername ne 'Guest' && -e "$memberdir/$eventusername.dat" ) {
			&LoadUser($eventusername);
			$mname = $userprofile{$eventusername}->[1] || $mname || $txt{'28'};
			$mname2 = $mname;
			$mname = qq~<A HREF="$scripturl?action=viewprofile;username=$useraccount{$eventusername}" alt="$txt{'27'}: $eventusername">$mname</A>~;
		}
		else {
			$mname = $txt{'28'};
			$mname2 = $mname;
		}
####### Media Player mod
		$mediausername = $mname2;
####### Media Player mod end
		$message = $commentview; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$commentview = $message;
		$eventnamesend = ${dayvars[$entrynum]}[0];    #bypass UBBC for SendEvent
		$message = ${dayvars[$entrynum]}[0]; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		${dayvars[$entrynum]}[0] = $message;
		$yymain .= qq~
  <TR>
    <TD class="newcal1" width="20%">$ecaltxt{'31'}</TD>
    <TD class="newcal1" align=left>  ${$dayvars[$entrynum]}[0]</TD>
  </TR><TR>
    <TD class="newcal2" width="20%">$ecaltxt{'50'}</TD>
    <TD class="newcal2" align=left>${$dayvars[$entrynum]}[1]</TD>
  </TR><TR>
    <TD class="newcal3" width="20%">$ecaltxt{'35'}</TD>
    <TD class="newcal3" align=left>$commentview</TD>
  </TR><TR>
    <TD class="newcal1" width="20%">$ecaltxt{'54'}</TD>
    <TD class="newcal1" align=left> $mname</TD>
  </TR>
  <TR>
    <TD colspan="2">
      <FORM action="$cgi;action=newcalendar;acttype=editdata" method="POST">
	  <INPUT TYPE="hidden" NAME="entrynum" VALUE="$entrynum">
        <INPUT name="selmonth" type=HIDDEN value="$seldate[0]">
        <INPUT name="selday" type=HIDDEN value="$seldate[1]">
        <INPUT name="selyear" type=HIDDEN value="$seldate[2]">
	  <INPUT type=submit value="$ecaltxt{'139'}">
      </FORM>
    </TD>
  </TR>
		~;
	} # end username controlled exclusion
	} # end for each current entry
	if ($userhasanevent == 0) {
		$yymain .= qq~
<TR>
  <TD class="newcal31">$ecaltxt{'140'}</TD>
</TR>
~; 
	}
	$yymain .= qq~
</TABLE>
<HR width="80%">

<FORM action="$cgi;action=newcalendar;acttype=editdata" method="POST">
  <INPUT TYPE="hidden" NAME="entrynum" VALUE="$entrynum">
  <INPUT name="selmonth" type=HIDDEN value="$seldate[0]">
  <INPUT name="selday" type=HIDDEN value="$seldate[1]">
  <INPUT name="selyear" type=HIDDEN value="$seldate[2]">
  <INPUT type=submit value="$ecaltxt{'138'}">
</FORM>
</center>
<BR>
	~;
#####
} # End of routine
# EditData generates Edit Event page, called by CalMain
sub EditData {
	my($entrynum) = $FORM{'entrynum'};
	$seldate[0] = $FORM{'selmonth'};
	$seldate[1] = $FORM{'selday'};
	$seldate[2] = $FORM{'selyear'};
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		my($entrynum2) = 0;
		foreach $entry (@{ $dayinfo{$daynum} }) {
			my(@daydata) = split(/\{/,$entry);
			$dayvars[$entrynum2] = [ @daydata ];
			$entrynum2++;
		}
	}
	($thisdaymonth,$thismonth,$thisyear,$thisdayweek) = (gmtime($daynum))[3,4,5,6];
	$thisweekdayname = ($ecaltxt{'13'},$ecaltxt{'14'},$ecaltxt{'15'},$ecaltxt{'16'},$ecaltxt{'17'},$ecaltxt{'18'},$ecaltxt{'19'})[$thisdayweek];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	$thisyear += 1900;
	if ($newcaldate == 1) {
		$newcaldatestring = qq~$thisweekdayname $thisdaymonth. <A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selyear=$thisyear&acttype=display">$monthname</A> <A HREF="$scripturl?action=newcalendar&selyear=$thisyear&acttype=disyear">$thisyear</A>~;
	} else {
		$newcaldatestring = qq~$thisweekdayname, <A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selyear=$thisyear&acttype=display">$monthname</A> $thisdaymonth, <A HREF="$scripturl?action=newcalendar&selyear=$thisyear&acttype=disyear">$thisyear</A>~;
	}
	my($entrynumstr)=$entrynum+1;
	my($title) = "";
	my($subject) = "$sbjdefault";
	my($repeatnum) = 1;
	my($repeatby) = "Daily";
	my($message) = "";
	my($eventusername) = 'Invalid user name placeholder'; #Sets variable to string no legitimate user name could possibly be.
	chomp $newcaladmingroup;
	@newcaladmingrouplist = split(",",$newcaladmingroup);
	$newcaladmingroupflag = 0;
	foreach $newcaladmingroupitem (@newcaladmingrouplist) {
		if ($settings[7] eq $newcaladmingroupitem) { $newcaladmingroupflag = 1; }
	}
	$yymain .= qq~
<CENTER>
  <SPAN class="newcal32">$ecaltxt{'108'}$newcaldatestring</SPAN>
  <FORM method="POST"  enctype="application/x-www-form-urlencoded">
    <INPUT type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
  </FORM>
  <HR width="80%">
</CENTER>
	~;
#	$newcalmax2 = $newcalmax - 1;
# note: need to pass $entrynum from ViewData or new entries will initiate
#	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
		if (${$dayvars[$entrynum]}[1] !~ /DELETED/) {
			$title = ${$dayvars[$entrynum]}[0] if (defined(${$dayvars[$entrynum]}[0]));
			$subject = ${$dayvars[$entrynum]}[1] if (defined(${$dayvars[$entrynum]}[1]));
			$message = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
			($message,$dummy) = split('',$message);
			$message =~ s~<br>~\n~g;
			$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
			$repeatby = ${$dayvars[$entrynum]}[4] if (defined(${$dayvars[$entrynum]}[4]));
			$repeatnum = ${$dayvars[$entrynum]}[5] if (defined(${$dayvars[$entrynum]}[5]));
		}
		if($username eq $eventusername || $settings[7] eq 'Administrator' || $newcaladmingroupflag == 1 || $eventusername eq 'Invalid user name placeholder') {
			if($eventusername eq 'Invalid user name placeholder') {$eventusername = $username};  #Sets new events to current username
##### Get Display name
		# Load the current nickname of the account name of the event poster.
		if( $eventusername ne 'Guest' && -e "$memberdir/$eventusername.dat" ) {
			&LoadUser($eventusername);
			$mname2 = $userprofile{$eventusername}->[1] || $mname2 || $txt{'28'};
		}
		else {
			$mname2 ||= $txt{'28'};
		}
##### Get Display name end
			$yymain .= qq~
<FORM method="post" action="$scripturl?action=newcalendar" enctype="application/x-www-form-urlencoded" name="postmodify" onSubmit="return submitproc()">
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<script language="JavaScript1.2" type="text/javascript">
<!--
function showimage() {
   document.images.icons.src="$imagesdir/"+document.postmodify.icon.options[document.postmodify.icon.selectedIndex].value+".gif";
}
//-->
</script>
  <INPUT name="formnum" type=HIDDEN value="$entrynum">
  <INPUT name="selmonth" type=HIDDEN value="$seldate[0]">
  <INPUT name="selday" type=HIDDEN value="$seldate[1]">
  <INPUT name="selyear" type=HIDDEN value="$seldate[2]">
  <INPUT name="eventusername" type=HIDDEN value="$eventusername">
  <TABLE border=2 width=90%>
    <CAPTION class="newcal18">$ecaltxt{'41'}$entrynumstr</CAPTION>
    <TR>
      <TD class="newcal1">$ecaltxt{'31'}</TD>
      <TD class="newcal1" align=center>
        <INPUT name="title" type=text size=14 maxlength=18 value="$title">
      </TD>
      <TD class="newcal8">$ecaltxt{'37'}</TD>
      <TD class="newcal8" align=center>
        <INPUT name="repeatnum" type=text size=2  maxlength=2 value="$repeatnum">
      </TD>
      <TD class="newcal8" align=center>
        <SELECT name="repeatby" size=1 value="$repeatby">
			~;
#### EMS addon
			foreach $item ($ecaltxt{'43'},$ecaltxt{'43a'},$ecaltxt{'44'},$ecaltxt{'45'},$ecaltxt{'46'},$ecaltxt{'46a'},$ecaltxt{'42'}) {
#### end EMS addon
				if($repeatby =~ /$item/) {
					$yymain .= qq~	  <OPTION selected>$item(s)<BR>~;
				}
				else {
					$yymain .= qq~	  <OPTION>$item(s)<BR>~;
				}
			}
			$yymain .= qq~
        </SELECT>
      </TD>
    </TR><TR>
      <TD class="newcal2" valign=top>$ecaltxt{'50'}</TD>
      <TD class="newcal2" valign=top align=center>
        <SELECT name="subject" size=4 value="$subject">
			~;
			foreach $item (@sbjlist) {
				chomp $item;
				if( $subject eq $item ) {
					$yymain .= qq~	  <OPTION selected>$item<BR>~;
				}
				else {
					$yymain .= qq~	  <OPTION>$item<BR>~;
				}
			}
			$yymain .= qq~
        </SELECT>
      </TD>
      <TD class="newcal3" colspan=3 align=center>~;
########
if($enable_ubbc && $showyabbcbutt) {
	$yymain .= qq~
    <table width="100%" cellpadding="3" cellspacing="0" class="newcal3">
      <tr>
        <td class="newcal3" width="23%"><font size=2><b>$txt{'252'}:</b></font></td>
        <td valign=middle class="newcal3">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:bold()><img src='$imagesdir/bold.gif' align=bottom width=23 height=22 alt='$txt{'253'}' border=0></a>");
          document.write("<a href=javascript:italicize()><img src='$imagesdir/italicize.gif' align=bottom width=23 height=22 alt='$txt{'254'}' border='0'></a>");
          document.write("<a href=javascript:underline()><img src='$imagesdir/underline.gif' align=bottom width=23 height=22 alt='$txt{'255'}' border='0'></a>");
          document.write("<a href=javascript:strike()><img src='$imagesdir/strike.gif' align=bottom width=23 height=22 alt='$txt{'441'}' border='0'></a>");
          document.write("<a href=javascript:glow()><img src='$imagesdir/glow.gif' align=bottom width=23 height=22 alt='$txt{'442'}' border='0'></a>");
          document.write("<a href=javascript:shadow()><img src='$imagesdir/shadow.gif' align=bottom width=23 height=22 alt='$txt{'443'}' border='0'></a>");
          document.write("<a href=javascript:move()><img src='$imagesdir/move.gif' align=bottom width=23 height=22 alt='$txt{'439'}' border='0'></a>");
          document.write("<a href=javascript:pre()><img src='$imagesdir/pre.gif' align=bottom width=23 height=22 alt='$txt{'444'}' border='0'></a>");
          document.write("<a href=javascript:left()><img src='$imagesdir/left.gif' align=bottom width=23 height=22 alt='$txt{'445'}' border='0'></a>");
          document.write("<a href=javascript:center()><img src='$imagesdir/center.gif' align=bottom width=23 height=22 alt='$txt{'256'}' border='0'></a>");
          document.write("<a href=javascript:right()><img src='$imagesdir/right.gif' align=bottom width=23 height=22 alt='$txt{'446'}' border='0'></a>");
          document.write("<a href=javascript:hr()><img src='$imagesdir/hr.gif' align=bottom width=23 height=22 alt='$txt{'531'}' border='0'></a>");
          document.write("<a href=javascript:size()><img src='$imagesdir/size.gif' align=bottom width=23 height=22 alt='$txt{'532'}' border='0'></a>");
          document.write("<a href=javascript:font()><img src='$imagesdir/face.gif' align=bottom width=23 height=22 alt='$txt{'533'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        <select name="color" onChange="showcolor(this.options[this.selectedIndex].value)">
         <option value="Black" selected>$txt{'262'}</option>
         <option value="Red">$txt{'263'}</option>
         <option value="Yellow">$txt{'264'}</option>
         <option value="Pink">$txt{'265'}</option>
         <option value="Green">$txt{'266'}</option>
         <option value="Orange">$txt{'267'}</option>
         <option value="Purple">$txt{'268'}</option>
         <option value="Blue">$txt{'269'}</option>
         <option value="Beige">$txt{'270'}</option>
         <option value="Brown">$txt{'271'}</option>
         <option value="Teal">$txt{'272'}</option>
         <option value="Navy">$txt{'273'}</option>
         <option value="Maroon">$txt{'274'}</option>
         <option value="LimeGreen">$txt{'275'}</option>
        </select>
        <br>
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "WebTV Plus Receiver" && navigator.appVersion.charAt(0) >= 3) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:flash()><img src='$imagesdir/flash.gif' align=bottom width=23 height=22 alt='$txt{'433'}' border='0'></a>");
          document.write("<a href=javascript:hyperlink()><img src='$imagesdir/url.gif' align=bottom width=23 height=22 alt='$txt{'257'}' border='0'></a>");
          document.write("<a href=javascript:ftp()><img src='$imagesdir/ftp.gif' align=bottom width=23 height=22 alt='$txt{'434'}' border='0'></a>");
          document.write("<a href=javascript:image()><img src='$imagesdir/img.gif' align=bottom width=23 height=22 alt='$txt{'435'}' border='0'></a>");
          document.write("<a href=javascript:emai1()><img src='$imagesdir/email2.gif' align=bottom width=23 height=22 alt='$txt{'258'}' border='0'></a>");
          document.write("<a href=javascript:table()><img src='$imagesdir/table.gif' align=bottom width=23 height=22 alt='$txt{'436'}' border='0'></a>");
          document.write("<a href=javascript:trow()><img src='$imagesdir/tr.gif' align=bottom width=23 height=22 alt='$txt{'437'}' border='0'></a>");
          document.write("<a href=javascript:tcol()><img src='$imagesdir/td.gif' align=bottom width=23 height=22 alt='$txt{'449'}' border='0'></a>");
          document.write("<a href=javascript:superscript()><img src='$imagesdir/sup.gif' align=bottom width=23 height=22 alt='$txt{'447'}' border='0'></a>");
          document.write("<a href=javascript:subscript()><img src='$imagesdir/sub.gif' align=bottom width=23 height=22 alt='$txt{'448'}' border='0'></a>");
          document.write("<a href=javascript:teletype()><img src='$imagesdir/tele.gif' align=bottom width=23 height=22 alt='$txt{'440'}' border='0'></a>");
          document.write("<a href=javascript:showcode()><img src='$imagesdir/code.gif' align=bottom width=23 height=22 alt='$txt{'259'}' border='0'></a>");
          document.write("<a href=javascript:quote()><img src='$imagesdir/quote2.gif' align=bottom width=23 height=22 alt='$txt{'260'}' border='0'></a>");
          document.write("<a href=javascript:list()><img src='$imagesdir/list.gif' align=bottom width=23 height=22 alt='$txt{'261'}' border='0'></a>");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
      </tr>
~;
}
else {
	$yymain .= qq~
        <table width="100%" cellpadding="3" cellspacing="0" class="newcal3">
~;
}
	$yymain .= qq~
      <tr>
        <td class="newcal3" width="23%"><font size=2><b>$txt{'297'}:</b></font></td>
        <td valign=middle class="newcal3">
        <script language="JavaScript1.2" type="text/javascript">
        <!--
        if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Konqueror" && navigator.appVersion.charAt(0) >= 2)) {
          document.write("<a href=javascript:smiley()><img src='$imagesdir/smiley.gif' align=bottom alt='$txt{'287'}' border='0'></a> ");
          document.write("<a href=javascript:wink()><img src='$imagesdir/wink.gif' align=bottom alt='$txt{'292'}' border='0'></a> ");
          document.write("<a href=javascript:cheesy()><img src='$imagesdir/cheesy.gif' align=bottom alt='$txt{'289'}' border='0'></a> ");
          document.write("<a href=javascript:grin()><img src='$imagesdir/grin.gif' align=bottom alt='$txt{'293'}' border='0'></a> ");
          document.write("<a href=javascript:angry()><img src='$imagesdir/angry.gif' align=bottom alt='$txt{'288'}' border='0'></a> ");
          document.write("<a href=javascript:sad()><img src='$imagesdir/sad.gif' align=bottom alt='$txt{'291'}' border='0'></a> ");
          document.write("<a href=javascript:shocked()><img src='$imagesdir/shocked.gif' align=bottom alt='$txt{'294'}' border='0'></a> ");
          document.write("<a href=javascript:cool()><img src='$imagesdir/cool.gif' align=bottom alt='$txt{'295'}' border='0'></a> ");
          document.write("<a href=javascript:huh()><img src='$imagesdir/huh.gif' align=bottom alt='$txt{'296'}' border='0'></a> ");
          document.write("<a href=javascript:rolleyes()><img src='$imagesdir/rolleyes.gif' align=bottom alt='$txt{'450'}' border='0'></a> ");
          document.write("<a href=javascript:tongue()><img src='$imagesdir/tongue.gif' align=bottom alt='$txt{'451'}' border='0'></a> ");
          document.write("<a href=javascript:embarassed()><img src='$imagesdir/embarassed.gif' align=bottom alt='$txt{'526'}' border='0'></a> ");
          document.write("<a href=javascript:lipsrsealed()><img src='$imagesdir/lipsrsealed.gif' align=bottom alt='$txt{'527'}' border='0'></a> ");
          document.write("<a href=javascript:undecided()><img src='$imagesdir/undecided.gif' align=bottom alt='$txt{'528'}' border='0'></a> ");
          document.write("<a href=javascript:kiss()><img src='$imagesdir/kiss.gif' align=bottom alt='$txt{'529'}' border='0'></a> ");
          document.write("<a href=javascript:cry()><img src='$imagesdir/cry.gif' align=bottom alt='$txt{'530'}' border='0'></a> ");
        }
        else { document.write("<font size='1'>$txt{'215'}</font>"); }
        //-->
        </script>
        <noscript>
        <font size="1">$txt{'215'}</font>
        </noscript>
        </td>
     </tr>
</table>
~;
############Remove these
$yymain .=qq~
        <TEXTAREA name="message" rows=12 cols=70 wrap="physical" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);">$message</TEXTAREA>
      </TD>
    </TR><TR>
      <TD class="newcal9" colspan=2>
        <INPUT name="deldata" type=submit value="$ecaltxt{'47'}$entrynumstr">
      </TD>
      <TD class="newcal10">$ecaltxt{'54'}</TD>
      <TD class="newcal10" colspan=1>$mname2</TD>
      <TD class="newcal11" colspan=1>
        <INPUT name="newdata" type=submit value="$ecaltxt{'48'}$entrynumstr">
      </TD>
    </TR>
  </TABLE>
</FORM>
			~;
# <script language="JavaScript"> <!--
#   document.postmodify.message.focus();
# //--> </script>

		}  # This bracket is the end of the username controlled exclusion
#		$entrynumstr++;
		$title = "";
		$subject = "$sbjdefault";
		$repeatnum = 1;
		$repeatby = "Daily";
		$message = "";
		$eventusername = 'Invalid user name placeholder'; #reset the variable for the next iteration
#	} end of individual entry
	$yymain .=qq~
<SPAN class="newcal20">$ecaltxt{'53'}</SPAN>
<BR>
<TABLE border="0">
    <TR>
      <TD valign=top class="newcal19">$ecaltxt{'31'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'32'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'33'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'34'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'35'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'36'}</TD>
    </TR><TR>
      <TD valign=top class="newcal19">$ecaltxt{'37'}</TD>
      <TD valign=top class="newcal19">$ecaltxt{'38'}</TD>
    </TR>
</TABLE>
<CENTER>
  <HR width="80%">
</CENTER>
	~;
} # end routine
# NewData writes new enteries to database file, called by CalMain sub
# Calls CompactCal
sub NewData {
	if( $seldate[2] > 2037) { $seldate[2] = 2037; }
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);

	my($arrayloc) = $FORM{'formnum'};
	my($title) = $FORM{'title'};
	my($subject) = $FORM{'subject'};
	my($message) = $FORM{'message'};
	my($eventusername) = $FORM{'eventusername'};
	my($repeatby) = $FORM{'repeatby'};
	my($repeatnum) = $FORM{'repeatnum'};

	$title =~ s/\cM//g;
	$title =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$title =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$title =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	$title =~ s~www\.~www \.~;
	$eventusername =~ tr/!-~/ /cs;
	if (length($message)>$MaxMessLen) { &fatal_error($txt{'499'}); }
	&spam_protection;
	$message =~ s/\cM//g;
	$message =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$message =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$message =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($message);
	$message =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$message =~ s~\n~<br>~g;
	$repeatnum =~ tr/!-~/ /cs;
	$title =~ s/[\{\|]//g;
	$subject =~ s/[\{\|]//g;
	$message =~ s/[\{\|]//g;
	$eventusername =~ s/[\{\|]//g;
	$repeatby =~ s/[\{\|]//g;
	$repeatnum =~ s/[\{\|]//g;
#####
	@sbjlist = split(" ",$sbjlist);
	my($subjectcheck) = 0;
	foreach $item (@sbjlist) {
		chomp $item;
		if( $subject eq $item ) { $subjectcheck = 1; }
	}
	if( $subjectcheck == 0 ) { &fatal_error($ecaltxt{'115'}); }
#####
	$subject = "DELETED" if($acttype=~/deldata/);
	my($dbentry) = join( '{',$title,$subject,$message,$eventusername,$repeatby,$repeatnum);
	${$dayinfo{$daynum}}[$arrayloc]="$dbentry";
	my($dbrow) = "$daynum";
	foreach $one (@{$dayinfo{$daynum}}) {
		$dbrow = join('|',$dbrow,$one);
	}
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,">>$dbfile");
	print(DBFILE "$dbrow\n");
	fclose(DBFILE);
	CompactCal();
} # end routine
#CompactCal removes duplicate calendar entries.  Called by sub NewData.
# Only last record for a date is kept in hash since index is reused.
# Since this sub is run each time NewData is called, the database
# should never contain duplicate date info.  In campactdayinfo
# hash: keys are index dates and values are complete date-event strings.
sub CompactCal {
	my %compactdayinfo;
	$dropdeaddate = timegm(0,0,0,1,0,2037);
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,$dbfile);
	$dummy=<DBFILE>; # read first line which is always empty
	while ($strline=<DBFILE>) {
		chop($strline);
		@line = split(/\|/,$strline);
		my($index) = shift(@line);
		if( $index > $dropdeaddate ) { $index = $dropdeaddate; }	# This sets maximum event date to 2037
		$compactdayinfo{$index} = $strline;
	}
	fclose(DBFILE);
# now write events back to dbfile without duplicates.
	fopen(DBFILE, ">$dbfile");
	print DBFILE qq~\n~;
	while (($dateindex, $dayevents) = each %compactdayinfo) {
		print DBFILE qq~$dayevents\n~;
	}
	fclose(DBFILE);
}
1;